/*
 * *##% 
 * Maven helper plugin
 * Copyright (C) 2009 CodeLutin
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 *
 * You should have received a copy of the GNU General Lesser Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * ##%*
 */
package org.nuiton.util;

import java.io.File;

/** 
 * @author chemit
 * @deprecated since 1.0.3, move to package org.nuiton.plugin (removed in 1.1.0)
 */
@Deprecated
public class FileUpdaterHelper {

    static public MirroredFileUpdater newJavaFileUpdater() {
        return newJavaFileUpdater(null, null);
    }

    static public MirroredFileUpdater newJaxxFileUpdater() {
        return newJaxxFileUpdater(null, null);
    }

    static public MirroredFileUpdater newJavaFileUpdater(File src, File dst) {
        return new JavaFileUpdater(src, dst);
    }

    static public MirroredFileUpdater newJaxxFileUpdater(File src, File dst) {
        return new JaxxFileUpdater(src, dst);
    }

    /**
     * To test if a java source file is newser than his compiled class
     *
     * @author chemit
     */
    public static class JavaFileUpdater extends MirroredFileUpdater {

        protected JavaFileUpdater(File sourceDirectory, File destinationDirectory) {
            super(".java", ".class", sourceDirectory, destinationDirectory);
        }

        @Override
        public File getMirrorFile(File f) {
            String file = f.getAbsolutePath().substring(prefixSourceDirecotory);
            String mirrorRelativePath = file.substring(0, file.length() - 4) + "class";
            return new File(destinationDirectory + File.separator + mirrorRelativePath);
        }
    }

    /**
     * To test if a jaxx source file is newser than his generated java source file
     *
     * @author chemit
     */
    public static class JaxxFileUpdater extends MirroredFileUpdater {

        protected JaxxFileUpdater(File sourceDirectory, File destinationDirectory) {
            super(".jaxx", ".java", sourceDirectory, destinationDirectory);
        }

        @Override
        public File getMirrorFile(File f) {
            String file = f.getAbsolutePath().substring(prefixSourceDirecotory);
            String mirrorRelativePath = file.substring(0, file.length() - 4) + "java";
            return new File(destinationDirectory + File.separator + mirrorRelativePath);
        }
    }
}
